{% extends 'base.html.twig' %}

{% form_theme form _self %}

{% block _device_ips_entry_widget %}
    <tr class="ipRow" data-pool-id="{% if value and value.mikrotikPool %}{{ value.mikrotikPool.id }}{% endif %}">
        <td class="ipRowPoolName">{% if value and value.mikrotikPool %}{{ value.mikrotikPool.nome }} ({{ value.mikrotikPool.dottedIpStart }} - {{ value.mikrotikPool.dottedIpEnd }}){% endif %}</td>
        <td>{{ form_widget(form.ip) }}</td>
        <td>
            {{ form_widget(form.mikrotikPool) }}
            <a class="deleteBt btn btn-danger" onclick="deleteIpRow(this)">Elimina</a>
        </td>
    </tr>

    {% if not form.ip.vars.valid %}
    <tr>
        <td colspan="3">{{ form_errors(form.ip, {'style': "color: red"}) }}</td>
    </tr>
    {% endif %}
{% endblock %}


{% block body %}
    <main class='main-content bgc-grey-100'>
        <div id='mainContent'>

    <h1>Aggiunta di un nuovo dispositivo</h1>

    <form  action="{{ path('device_create') }}" method="post" >
        {{ form_errors(form, { 'global_errors': true }) }}
        {{ form_row(form.device) }}
        {{ form_row(form.mac) }}
        {{ form_row(form.mikrotikList) }}

        {{ form_label(form.ips) }}
        <table id="ipList" data-prototype="{{ form_widget(form.ips.vars.prototype)|e }}">

        </table>
        {% do form.ips.setRendered %}

        <div id="ipAddCont">
            <select name="ipAddMikrotikPool" id="ipAddMikrotikPool">
                {% for mikrotikPool in mikrotikPoolList %}
                    <option value="{{ mikrotikPool.id }}">{{ mikrotikPool.nome }} ({{ mikrotikPool.dottedIpStart }} - {{ mikrotikPool.dottedIpEnd }})</option>
                {% endfor %}
            </select>
            <a class="btn btn-secondary" id="ipAddMikrotikPoolBtn">Aggiungi</a>
        </div>

        {{ form_row(form.bypassHotspot) }}
        {{ form_row(form.active) }}

        {{ form_rest(form) }}

        <div class="row sendBtnArea">
            <div class="col-sm-4">
                <button type="submit" class="btn btn-success">Aggiungi questo dispositivo</button>
            </div>
            <div class="col-sm-4 text-sm-center"></div>
            <div class="col-sm-4 text-sm-right">
                <a href="{{ path('device') }}" class="btn btn-info">
                    Ritorna alla lista
                </a>
            </div>
        </div>
    </form>
    </div>
</main>
{% endblock %}


{% block javascripts %}
    {{ parent() }}

    <script type="text/javascript">
        function deleteIpRow(el) {
            var $ipRow = $(el).parent().parent();
            $ipRow.remove();
        }

        $(document).ready(function() {
            var $poolSelect = $('#ipAddMikrotikPool');
            var $ipList = $("#ipList");
            var $ipAddMikrotikPoolBtn = $('#ipAddMikrotikPoolBtn');
            var poolLoading = false;

            $ipList.data('counter', $ipList.find(".ipRow").length);


            $ipAddMikrotikPoolBtn.click(function () {
                if(poolLoading)
                    return;

                var selectedPoolId = $poolSelect.val();
                var ipListRows = $ipList.find(".ipRow").toArray();

                for(var i in ipListRows) {
                    if ($(ipListRows[i]).data('pool-id') == selectedPoolId) {
                        alert("È già presente un indirizzo per il pool in questione");
                        return;
                    }
                }

                $.get("{{ path('mikrotik_pool_check_free_ip', {'id': "%id"}) }}".replace("%25id", selectedPoolId), function (data) {
                    var ip = "";
                    if (data.error !== undefined) {
                        alert('Si è verificato un errore: ' + data.error);
                    } else if (data.ip !== undefined || data.ip != "") {
                        ip = data.ip;
                    }

                    var counter =  $ipList.data('counter');
                    var baseName = "device_ips_"+counter;
                    var $newRow = $($ipList.data('prototype').replace(/__name__/g, counter));
                    $newRow.data('pool-id', selectedPoolId);
                    $newRow.children('.ipRowPoolName').append($poolSelect.children("option:selected").text());
                    $newRow.find("#"+baseName+"_ip").val(ip);
                    $newRow.find("#"+baseName+"_mikrotikPool").val(selectedPoolId);

                    $ipList.append($newRow);
                    $ipList.data('counter', counter + 1);
                    $ipAddMikrotikPoolBtn.text("Aggiungi");
                    poolLoading = false;
                }, 'json').fail(function() {
                    $ipAddMikrotikPoolBtn.text("Aggiungi");
                    poolLoading = false;
                });

                $ipAddMikrotikPoolBtn.text("Caricamento...");
                poolLoading = true;
            })

        });
    </script>


{% endblock %}
